import argparse, os, sys

parser = argparse.ArgumentParser(description='calculates a junction  statistic (on stderr) and optionally pipes specific filtered junctions to stdout.')
parser.add_argument("-u", "--bedu", dest='my_bedu',required=True, help="specifies the path to the splicesites.bed file")
parser.add_argument("-t", "--bedt", dest='my_bedt', help="specifies the path to the transsplice.bed file")
parser.add_argument("-m", "--minSup", dest='my_minSup', type=int, help="specifies the minimum junction support")
parser.add_argument("-M", "--filterM", action="store_true", help="provide if junctions  should be filtered out that have splice sites connecting to more than 100 other splice sites ")
parser.add_argument("-F", "--filterF", action="store_true", help="provide if junctions  should be filtered out that splice sites connecting other splice sites with 'too similar' regions")
parser.add_argument("-C", "--outC", action="store_true", help="provide if filtered circular junctions should be piped to stdout (can be combined with -N and/or -S)")
parser.add_argument("-N", "--outN", action="store_true", help="provide if filtered normal junctions should be piped to stdout (can be combined with -C and/or -S)")
parser.add_argument("-S", "--outS", action="store_true", help="provide if filtered strandswitch junctions should be piped to stdout (can be combined with -C and/or -N)")
parser.add_argument("-T", "--outT", action="store_true", help="provide if filtered trans splicing junctions should be piped to stdout (can not be combined with -N, -C and -S) ")

args = parser.parse_args()
bedu=os.path.abspath(args.my_bedu)
if(args.my_minSup):
    minSup=args.my_minSup
else:
    minSup=3
    
if(args.filterM):
    filterM=True
else:
    filterM=False
if(args.filterF):
    filterF=True
else:
    filterF=False


if(args.outC):
    outC=True
else:
    outC=False

if(args.outN):
    outN=True
else:
    outN=False

if(args.outS):
    outS=True
else:
    outS=False

if(args.outT):
    outT=True
else:
    outT=False




if((outT and outN) or (outT and outC) or (outT and outS)): 
    sys.exit("This is not allowed. (use -T not in combination with -N, -C or -S)")
    sys.exit(1)
counter=0
countersup=0

counterN=0
counterNsup=0
counterNP=0
counterNPsup=0
counterNPM=0
counterNPMsup=0

counterC=0
counterCsup=0
counterCP=0
counterCPsup=0
counterCPM=0
counterCPMsup=0
for line in open(bedu,'r'):
    counter+=1
    columns = line.strip().split('\t')
    fields = columns[3].strip().split(':')
    countersup+=int(fields[1])
    #circ
    if(fields[len(fields)-2]=='C'):
        counterC+=1
        counterCsup+=int(fields[1])
        if(filterF and filterM):
            if(fields[len(fields)-1]=='P'):
                counterCPsup+=int(fields[1])
                counterCP+=1
                if(int(fields[1])>=minSup):
                    counterCPM+=1
                    counterCPMsup+=int(fields[1])
                    if outC:
                        sys.stdout.write(line)
        elif(filterF):
            if(fields[len(fields)-1]!='F'):
                counterCPsup+=int(fields[1])
                counterCP+=1
                if(int(fields[1])>=minSup):
                    counterCPM+=1
                    counterCPMsup+=int(fields[1])
                    if outC:
                        sys.stdout.write(line)
        elif(filterM):
            if(fields[len(fields)-1]!='M'):
                counterCPsup+=int(fields[1])
                counterCP+=1
                if(int(fields[1])>=minSup):
                    counterCPM+=1
                    counterCPMsup+=int(fields[1])
                    if outC:
                        sys.stdout.write(line)
        else:
            counterCPsup+=int(fields[1])
            counterCP+=1
            if(int(fields[1])>=minSup):
                counterCPM+=1
                counterCPMsup+=int(fields[1])
                if outC:
                    sys.stdout.write(line)
            
    #normal
    else:
        counterN+=1
        counterNsup+=int(fields[1])
        if(filterF and filterM):
            if(fields[len(fields)-1]=='P'):
                counterNPsup+=int(fields[1])
                counterNP+=1
                if(int(fields[1])>=minSup):
                    counterNPM+=1
                    counterNPMsup+=int(fields[1])
                    if outN:
                        sys.stdout.write(line)
        elif(filterF):
            if(fields[len(fields)-1]!='F'):
                counterNPsup+=int(fields[1])
                counterNP+=1
                if(int(fields[1])>=minSup):
                    counterNPM+=1
                    counterNPMsup+=int(fields[1])
                    if outN:
                        sys.stdout.write(line)
        elif(filterM):
            if(fields[len(fields)-1]!='M'):
                counterNPsup+=int(fields[1])
                counterNP+=1
                if(int(fields[1])>=minSup):
                    counterNPM+=1
                    counterNPMsup+=int(fields[1])
                    if outN:
                        sys.stdout.write(line)
        else:
            counterNPsup+=int(fields[1])
            counterNP+=1
            if(int(fields[1])>=minSup):
                counterNPM+=1
                counterNPMsup+=int(fields[1])
                if outN:
                    sys.stdout.write(line)



if(args.my_bedt):

    counterD=0
    counterDsup=0
    counterDP=0
    counterDPsup=0
    counterDPM=0
    counterDPMsup=0

    counterS=0
    counterSsup=0
    counterSP=0
    counterSPsup=0
    counterSPM=0
    counterSPMsup=0


    counterDS=0
    counterDSsup=0
    counterDSP=0
    counterDSPsup=0
    counterDSPM=0
    counterDSPMsup=0
    bedt=os.path.abspath(args.my_bedt)
    lineNumberDS=1    
    lineNumberD=1
    toPrint=False
    toPrintS=False
    for line in open(bedt,'r'):
        
        if(toPrint):
            sys.stdout.write(line)
        if(toPrintS):
            sys.stdout.write(line)
        toPrint=False
        toPrintS=False
        columns = line.strip().split('\t')
        fields = columns[3].strip().split(':')
        #strandsplice
        if(fields[0]=="strandsplice"):
            counterS+=1
            counterSsup+=int(fields[1])
            if(filterF and filterM):
                if(fields[len(fields)-1]=='P'):
                    counterSPsup+=int(fields[1])
                    counterSP+=1
                    if(int(fields[1])>=minSup):
                        counterSPM+=1
                        counterSPMsup+=int(fields[1])
                        if outS:
                            sys.stdout.write(line)
            elif(filterF):
                if(fields[len(fields)-1]!='F'):
                    counterSPsup+=int(fields[1])
                    counterSP+=1
                    if(int(fields[1])>=minSup):
                        counterSPM+=1
                        counterSPMsup+=int(fields[1])
                        if outS:
                            sys.stdout.write(line)
            elif(filterM):
                if(fields[len(fields)-1]!='M'):
                    counterSPsup+=int(fields[1])
                    counterSP+=1
                    if(int(fields[1])>=minSup):
                        counterSPM+=1
                        counterSPMsup+=int(fields[1])
                        if outS:
                            sys.stdout.write(line)
            else:
                counterSPsup+=int(fields[1])
                counterSP+=1
                if(int(fields[1])>=minSup):
                    counterSPM+=1
                    counterSPMsup+=int(fields[1])
                    if outS:
                        sys.stdout.write(line)
        else:
            #distsplice
            if(fields[0]=="distsplice"):
                lineNumberD+=1
                
                if lineNumberD%2==0:
                    counterD+=1
                    counterDsup+=int(fields[3])
                    if(filterF and filterM):
                        if(fields[len(fields)-1]=='P'):
                            counterDPsup+=int(fields[3])
                            counterDP+=1
                            if(int(fields[3])>=minSup):
                                counterDPM+=1
                                counterDPMsup+=int(fields[3])
                                if outT:
                                    sys.stdout.write(line)
                                    toPrint=True
                                    
                    elif(filterF):
                        if(fields[len(fields)-1]!='F'):
                            counterDPsup+=int(fields[3])
                            counterDP+=1
                            if(int(fields[3])>=minSup):
                                counterDPM+=1
                                counterDPMsup+=int(fields[3])
                                if outT:
                                    sys.stdout.write(line)
                                    toPrint=True
                    elif(filterM):
                        if(fields[len(fields)-1]!='M'):
                            counterDPsup+=int(fields[3])
                            counterDP+=1
                            if(int(fields[3])>=minSup):
                                counterDPM+=1
                                counterDPMsup+=int(fields[3])
                                if outT:
                                    sys.stdout.write(line)
                                    toPrint=True
                    else:
                        counterDPsup+=int(fields[3])
                        counterDP+=1
                        if(int(fields[3])>=minSup):
                            counterDPM+=1
                            counterDPMsup+=int(fields[3])
                            if outT:
                                sys.stdout.write(line)
                                toPrint=True
                
                    
                        
            #diststrandsplice
            else:
                lineNumberDS+=1
                if lineNumberDS%2==0:
                    counterDS+=1
                    counterDSsup+=int(fields[3])
                    if(filterF and filterM):
                        if(fields[len(fields)-1]=='P'):
                            counterDSPsup+=int(fields[3])
                            counterDSP+=1
                            if(int(fields[3])>=minSup):
                                counterDSPM+=1
                                counterDSPMsup+=int(fields[3])
                                if outT:
                                    sys.stdout.write(line)
                                    toPrintS=True
                    elif(filterF):
                        if(fields[len(fields)-1]!='F'):
                            counterDSPsup+=int(fields[3])
                            counterDSP+=1
                            if(int(fields[3])>=minSup):
                                counterDSPM+=1
                                counterDSPMsup+=int(fields[3])
                                if outT:
                                    sys.stdout.write(line)
                                    toPrintS=True
                    elif(filterM):
                        if(fields[len(fields)-1]!='M'):
                            counterDSPsup+=int(fields[3])
                            counterDSP+=1
                            if(int(fields[3])>=minSup):
                                counterDSPM+=1
                                counterDSPMsup+=int(fields[3])
                                if outT:
                                    sys.stdout.write(line)
                                    toPrintS=True
                    else:
                        counterDSPsup+=int(fields[3])
                        counterDSP+=1
                        if(int(fields[3])>=minSup):
                            counterDSPM+=1
                            counterDSPMsup+=int(fields[3])
                            if outT:
                                sys.stdout.write(line)
                                toPrintS=True
               




if(args.my_bedt):
    if(filterF and filterM):
        sys.stderr.write("junctions tab junctions multiplied by read support\njunctions passing filter F and M\njunctions passing filter F and M with a minimum support of "+str(minSup)+"\nall:\n")
    elif(filterF):
        sys.stderr.write("junctions tab junctions multiplied by read support\njunctions passing filter F\njunctions passing filter F with a minimum support of "+str(minSup)+"\nall:\n")
    elif(filterM):
        sys.stderr.write("junctions tab junctions multiplied by read support\njunctions passing filter M\njunctions passing filter M with a minimum support of "+str(minSup)+"\nall:\n")
    else:
        sys.stderr.write("junctions tab junctions multiplied by read support\njunctions with a minimum support of "+str(minSup)+"\nall:\n")
    sys.stderr.write(str(counter+counterS+counterD+counterDS)+"\t"+str(countersup+counterSsup+counterDsup+counterDSsup)+
                 "\n"+str(counterNP+counterCP+counterSP+counterDP+counterDSP)+"\t"+str(counterNPsup+counterCPsup+counterSPsup+counterDPsup+counterDSPsup)+
                 "\n"+str(counterNPM+counterCPM+counterSPM+counterDPM+counterDSPM)+"\t"+str(counterNPMsup+counterCPMsup+counterSPMsup+counterDPMsup+counterDSPMsup)+
                 "\n\nnormal: \n"+str(counterN)+"\t"+str(counterNsup)+
                 "\n"+str(counterNP)+"\t"+str(counterNPsup)+
                 "\n"+str(counterNPM)+"\t"+str(counterNPMsup)+
                 "\n\ncircular\n"+str(counterC)+"\t"+str(counterCsup)+
                 "\n"+str(counterCP)+"\t"+str(counterCPsup)+
                 "\n"+str(counterCPM)+"\t"+str(counterCPMsup)+
                 "\n\nstrandsplice: \n"+str(counterS)+"\t"+str(counterSsup)+
                 "\n"+str(counterSP)+"\t"+str(counterSPsup)+
                 "\n"+str(counterSPM)+"\t"+str(counterSPMsup)+
                 "\n\ndistsplice: \n"+str(counterD)+"\t"+str(counterDsup)+
                 "\n"+str(counterDP)+"\t"+str(counterDPsup)+
                 "\n"+str(counterDPM)+"\t"+str(counterDPMsup)+
                 "\n\ndiststrandsplice:\n"+str(counterDS)+"\t"+str(counterDSsup)+
                 "\n"+str(counterDSP)+"\t"+str(counterDSPsup)+
                 "\n"+str(counterDSPM)+"\t"+str(counterDSPMsup)+"\n")

else:
    if(filterF and filterM):
        sys.stderr.write("junctions tab junctions multiplied by read support\njunctions passing filter F and M \njunctions passing filter F and M with a minimum support of ")
    elif(filterF):
        sys.stderr.write("junctions tab junctions multiplied by read support\njunctions passing filter F \njunctions passing filter Fwith a minimum support of ")
    elif(filterM):
        sys.stderr.write("junctions tab junctions multiplied by read support\njunctions passing filter M \njunctions passing filter M with a minimum support of ")
    else:
        sys.stderr.write("junctions tab junctions multiplied by read support\n\njunctions with a minimum support of ")



    sys.stderr.write(str(minSup)+"\nnormal and circular:\n"+
                 str(counter)+"\t"+str(countersup)+
                 "\n"+str(counterNP+counterCP)+"\t"+str(counterNPsup+counterCPsup)+
                 "\n"+str(counterNPM+counterCPM)+"\t"+str(counterNPMsup+counterCPMsup)+
                 "\n\nnormal: \n"+str(counterN)+"\t"+str(counterNsup)+
                 "\n"+str(counterNP)+"\t"+str(counterNPsup)+
                 "\n"+str(counterNPM)+"\t"+str(counterNPMsup)+
                 "\n\ncircular\n"+str(counterC)+"\t"+str(counterCsup)+
                 "\n"+str(counterCP)+"\t"+str(counterCPsup)+
                 "\n"+str(counterCPM)+"\t"+str(counterCPMsup)+"\n")
    
    
